import "Turbine";  
import "Turbine.UI"; 
import "Turbine.UI.Lotro";

Turbine.Shell.WriteLine("Predict In Game Time by ScrappyTheGreat.");

hiddenwindow = Turbine.UI.Window();
hiddenwindow:SetPosition(0, 0);
hiddenwindow:SetWantsKeyEvents(true);
hiddenwindow:SetVisible(false);

f12flag = 0;
visarray={}


opts = Turbine.PluginData.Load(Turbine.DataScope.Character, "pigt_opts"); -- or {mouseposx=150, mouseposy=100, timerseed=10350, minishow="yes"};

--opts = {}; -- delete this when not using /scripttools
if (opts == nil or opts.mouseposx == nil or opts.mouseposy == nil or opts.timerseed == nil or opts.minishow == nil or opts.ripcordflag == nil) then
opts = {};
opts.timerseed = 10350;
opts.mouseposx = 200;
opts.mouseposy = 150;
opts.minishow = "no";
opts.ripcordflag = 0;
opts.ripoption = 0;
Turbine.PluginData.Save(Turbine.DataScope.Character, "pigt_opts", opts)
end --if(opts~=nil)

if (opts.openparentwindowstartup == nil) then
   opts.openparentwindowstartup = true;
end


timerseed = opts.timerseed;
mouseposx=opts.mouseposx;
mouseposy=opts.mouseposy;
minishow=opts.minishow;
ripoption = opts.ripoption;
openparentwindowstartup = opts.openparentwindowstartup;


parentwindow = Turbine.UI.Lotro.Window();
parentwindow:SetPosition( 250, 150 ); 
--parentwindow:SetPosition( 5, 5 );
parentwindow:SetSize( 510, 400 ); 
parentwindow:SetText( "Predict In-Game Time" );
-- parentwindow:SetVisible( true );
parentwindow:SetVisible( openparentwindowstartup );


optionswindow = Turbine.UI.Lotro.Window();
optionswindow:SetPosition( 280, 130 ); 
optionswindow:SetSize( 510, 300 ); 
optionswindow:SetText( "PigT Options" );
optionswindow:SetZOrder(parentwindow:GetZOrder() + 1);
optionswindow:SetVisible( false );

optionstext1 = Turbine.UI.TextBox();
optionstext1:SetParent(optionswindow);
optionstext1:SetPosition(20, 40);
optionstext1:SetSize( 470, 100 );
optionstext1:SetBackColor( Turbine.UI.Color(0.2, 0.2, 0.2) );
-- optionstext1:SetText("\n     : Open main window on plugin startup");

optionsmainwindowcheck1 = Turbine.UI.Lotro.CheckBox();
optionsmainwindowcheck1:SetParent(optionstext1);
optionsmainwindowcheck1:SetPosition(25, 10);
optionsmainwindowcheck1:SetVisible(true);
 optionsmainwindowcheck1:SetText(" : Open main window on plugin startup");
optionsmainwindowcheck1:SetSize(350, 30);
optionsmainwindowcheck1:SetChecked( openparentwindowstartup );


optionsbutton = Turbine.UI.Lotro.Button();
optionsbutton:SetParent(parentwindow);
optionsbutton:SetSize(70, 20);
optionsbutton:SetPosition(405, 367);
optionsbutton:SetText("Options");



helpbutton = Turbine.UI.Lotro.Button();
helpbutton:SetParent(parentwindow);
helpbutton:SetSize(60, 20);
helpbutton:SetPosition(40, 367);
helpbutton:SetText("HELP!");

helpwindow = Turbine.UI.Lotro.Window();
helpwindow:SetPosition(350, 100);
helpwindow:SetSize(350, 350);
helpwindow:SetVisible(false);
helpwindow:SetText("Help");
helpwindow:SetZOrder(105);

helpwindowtext = Turbine.UI.Lotro.TextBox();
helpwindowtext:SetParent(helpwindow);
helpwindowtext:SetPosition(20, 40);
helpwindowtext:SetSize(310, 210);
helpwindowtext:SetReadOnly(true);
helpwindowtext:SetFont(Turbine.UI.Lotro.Font.Verdana18);
helpwindowtext:SetText("For help, visit the following website:\n\nhttp://my.lotro.com/user-511668/predict-in-game-time-updater/\n\nDo not click the Ripcord button unless the website specifically tells you to do so.  If you require further help, send a message to ScrappyTheGreat on the lotro forums: http://forums.lotro.com");


updatenumbertext = Turbine.UI.Lotro.TextBox();
updatenumbertext:SetParent(helpwindow);
updatenumbertext:SetPosition(120, 255);
updatenumbertext:SetSize(110, 20);
updatenumbertext:SetFont(Turbine.UI.Lotro.Font.Verdana14);
updatenumbertext:SetReadOnly(true);
updatenumbertext:SetText("Update Number");

updatenumber = Turbine.UI.Lotro.TextBox();
updatenumber:SetParent(helpwindow);
updatenumber:SetPosition(120, 280);
updatenumber:SetSize(110, 20);
updatenumber:SetFont(Turbine.UI.Lotro.Font.Verdana14);
updatenumber:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
updatenumber:SetText(timerseed);

opttextbox = Turbine.UI.Lotro.TextBox();
opttextbox:SetParent(helpwindow);
opttextbox:SetPosition(230, 255);
opttextbox:SetSize(55, 20);
opttextbox:SetFont(Turbine.UI.Lotro.Font.Verdana14);
opttextbox:SetReadOnly(true);
opttextbox:SetText("Option");

optnumber = Turbine.UI.Lotro.TextBox();
optnumber:SetParent(helpwindow);
optnumber:SetPosition(230, 280);
optnumber:SetSize(55, 20);
optnumber:SetFont(Turbine.UI.Lotro.Font.Verdana14);
optnumber:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
optnumber:SetText(ripoption);




ripcordbutton = Turbine.UI.Lotro.Button();
ripcordbutton:SetParent(helpwindow);
ripcordbutton:SetPosition(120, 305);
ripcordbutton:SetSize(110, 20);
ripcordbutton:SetForeColor(Turbine.UI.Color(1, 1, 0));
ripcordbutton:SetText("Ripcord");


ripcordflag = 0;

if (opts.ripcordflag ~= nil) then
  ripcordflag = opts.ripcordflag;
end -- if(ripcordflagnotnil)

nowtime = Turbine.Engine.GetLocalTime();
gametime = Turbine.Engine.GetGameTime();

ripcordbutton.Click = function(sender, args)

    ripcordflag = 1;
    if ( tonumber(updatenumber:GetText()) == nil ) then
        updatenumber:SetText("invalid number");
    else
        timerseed = tonumber(updatenumber:GetText());
        ripoption = tonumber(optnumber:GetText());
        opts.timerseed = timerseed;
        opts.ripcordflag = ripcordflag;
        opts.ripoption = ripoption;
        Turbine.PluginData.Save(Turbine.DataScope.Character, "pigt_opts", opts);
       if (ripoption == 1) then
        InitDawn = timerseed;
       elseif (ripoption == 2) then
        InitDawn = (gametime%11160) + timerseed;
       elseif (ripoption == 0) then
        InitDawn = nowtime - gametime + timerseed;
        ripcordflag = 0;
       else
        InitDawn = nowtime - gametime + timerseed;
       end
        Turbine.Shell.WriteLine("Ripcord used: " .. updatenumber:GetText() .. " option " .. ripoption );
     end -- if(invalidnumber)


end -- ripcordbutton.click



helpbutton.Click = function(sender, args)

    helpwindow:SetVisible(not helpwindow:IsVisible() );

end -- helpbutton click


-- Find current RL time
getdate = Turbine.Engine.GetDate();
currenthour = getdate.Hour;
currentminute = getdate.Minute;
isDST = getdate.IsDST;  -- Day Light Savings adjustment

dstvar = 1;
if (isDST) then
    dstvar = 0;
end



timezone = math.floor((Turbine.Engine.GetLocalTime() % 86400) / 3600) - currenthour;
currentampm = "am";  -- initialize currentampm


label1 = Turbine.UI.TextBox();
 label1:SetParent( parentwindow );
 label1:SetSelectable( true );
 label1:SetPosition( 20, 60 );
 label1:SetSize( 470, 55 );
 label1:SetBackColor( Turbine.UI.Color( 0.15, 0.15, 0.15 ) );
label1:SetVisible(true);


label2 = Turbine.UI.TextBox();
 label2:SetParent( parentwindow );
 label2:SetSelectable( true );
 label2:SetPosition( 20, 130 );
 label2:SetSize( 470, 180 );
 label2:SetBackColor( Turbine.UI.Color( 0.15, 0.15, 0.15 ) );
label2:SetVisible(true);
label2:SetFont(Turbine.UI.Lotro.Font.Verdana14);
label2:SetTextAlignment( Turbine.UI.ContentAlignment.BottomCenter );


label3 = Turbine.UI.TextBox();
 label3:SetParent( parentwindow );
 label3:SetSelectable( true );
 label3:SetPosition( 20, 325 );
 label3:SetSize( 470, 35 );
 label3:SetBackColor( Turbine.UI.Color( 0.15, 0.15, 0.15 ) );
label3:SetVisible(true);




RLtimetext = Turbine.UI.Lotro.TextBox();
-- RLtimetext:SetParent(parentwindow);
RLtimetext:SetParent(label1);
-- RLtimetext:SetPosition(20,40);
RLtimetext:SetPosition(0, 5);
RLtimetext:SetSize(160, 20);
RLtimetext:SetFont(Turbine.UI.Lotro.Font.Verdana16);
  RLtimetext:SetBackColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) );
RLtimetext:SetReadOnly(true);
RLtimetext:SetVisible(true);
RLtimetext:SetText("Current Real-life time: ");

currentRLtimetext = Turbine.UI.Lotro.TextBox();
-- currentRLtimetext:SetParent(parentwindow);
currentRLtimetext:SetParent(label1);
-- currentRLtimetext:SetPosition(170,40);
currentRLtimetext:SetPosition(160,5);
currentRLtimetext:SetSize(75, 20);
currentRLtimetext:SetFont(Turbine.UI.Lotro.Font.Verdana16);
 currentRLtimetext:SetBackColor( Turbine.UI.Color( 0.2, 0.5, 1 ) );
currentRLtimetext:SetReadOnly(true);
currentRLtimetext:SetVisible(true);  
currentRLtimetext:SetForeColor( Turbine.UI.Color( 1, 0.85, 0 ) );

getdate = Turbine.Engine.GetDate();
currenthour = getdate.Hour;
currentminute = getdate.Minute;
currentsecond = getdate.Second;

getTime = function(sender, args)

oldtime=currentsecond;

getdate = Turbine.Engine.GetDate();
currenthour = getdate.Hour;
currentminute = getdate.Minute;
currentsecond = getdate.Second;  -- VITAL: keep this line of code!  it is used in calculations for updateControl function and countdown function

end -- getTime function

getTime();


getRLtimetext = function(sender, args)

if (currenthour > 11) then
 apm = "pm";
else
 apm = "am";
end -- if(currenthour>11)

if (currenthour > 12) then
  currenthour = currenthour - 12;
end -- if(currenthour>12)

-- currentRLtimetext:SetText("Current Real-life time: " .. currenthour .. "h " .. currentminute .. "m " .. currentsecond .. "s");  -- remove seconds after done debugging
if (currentminute < 10) then
 currentminuteout = "0" .. currentminute;
else
 currentminuteout = currentminute;
end

currentRLtimetext:SetText( currenthour .. ":" .. currentminuteout .. apm);  

end -- getRLtimetext function

getRLtimetext();


-- End current RL time code

-- Start current IG (In-Game) time code

timer = "Day-time: Dawn";

IGtimetext = Turbine.UI.Lotro.TextBox();
-- IGtimetext:SetParent(parentwindow);
IGtimetext:SetParent(label1);
-- IGtimetext:SetPosition(20,65);
IGtimetext:SetPosition(0,30);
IGtimetext:SetSize(160, 20);
IGtimetext:SetFont(Turbine.UI.Lotro.Font.Verdana16);
 IGtimetext:SetBackColor( Turbine.UI.Color( 0.5, 0.5, 0.5 ) );
IGtimetext:SetReadOnly(true);
IGtimetext:SetVisible(true);
IGtimetext:SetText("Current In-game time:");


currentIGtimetext = Turbine.UI.Lotro.TextBox();
-- currentIGtimetext:SetParent(parentwindow);
currentIGtimetext:SetParent(label1);
-- currentIGtimetext:SetPosition(170,65);
currentIGtimetext:SetPosition(160, 30);
currentIGtimetext:SetSize(205, 20);
currentIGtimetext:SetFont(Turbine.UI.Lotro.Font.Verdana16);
 currentIGtimetext:SetBackColor( Turbine.UI.Color( 0.2, 0.5, 1 ) );
currentIGtimetext:SetForeColor( Turbine.UI.Color( 1, 0.85, 0 ) );
 currentIGtimetext:SetReadOnly(true);
currentIGtimetext:SetVisible(true);
currentIGtimetext:SetText(timer);

nowtime = Turbine.Engine.GetLocalTime();
gametime = Turbine.Engine.GetGameTime();


if (ripoption == 0) then
    ripcordflag = 0;
end

if (ripcordflag<1) then
    InitDawn =  nowtime - gametime + timerseed;
elseif (ripcordflag == 1 and ripoption == 1) then
    InitDawn = timerseed;
elseif (ripcordflag == 1 and ripoption == 2) then
    InitDawn = (gametime%11160) + timerseed;
else
    InitDawn =  nowtime - gametime + timerseed;
end -- if(ripcordflag)

difftimer = 0;

getIGtimetext = function(sender, args)
 
nowtime = Turbine.Engine.GetLocalTime(); 
endtime = nowtime + difftimer - InitDawn;
adjust = endtime % 11160;


if (adjust <= 572) then
 timer = "Day-time: Dawn";
 durationarraypos = 1;
elseif (adjust <= 2294) then
 timer = "Day-time: Morning";
 durationarraypos = 2;
elseif (adjust <= 3361) then
 timer = "Day-time: Noon";
 durationarraypos = 3;
elseif (adjust <= 5039) then
 timer = "Day-time: Afternoon";
 durationarraypos = 4;
elseif (adjust <= 6140) then
 timer = "Day-time: Dusk";
 durationarraypos = 5;
elseif (adjust <= 6710) then
 timer = "Night-time: Gloaming";
 durationarraypos = 6;
elseif (adjust <= 8389) then
 timer = "Night-time: Evening";                                                          
 durationarraypos = 7;
elseif (adjust <= 8928) then
 timer = "Night-time: Midnight";
 durationarraypos = 8;
elseif (adjust <= 10069) then
 timer = "Night-time: Late Watches";
 durationarraypos = 9;
elseif (adjust <= 11160) then
 timer = "Night-time: Foredawn";
 durationarraypos = 10;
   
elseif (adjust > 11160) then
 timer = "Nil-time: Scrappy needs to check his math";
end -- if(adjust <= 572)

   currentIGtimetext:SetText(timer);

-- Turbine.Shell.WriteLine("difftimer = " .. difftimer);
end -- getIGtimetext function

getIGtimetext();

-- End current IG time code


-- Start IG -> RL

IGtoRLtext1 = Turbine.UI.Lotro.TextBox();
IGtoRLtext1:SetParent(label2);
IGtoRLtext1:SetPosition(10, 78);
IGtoRLtext1:SetSize(225, 20);
IGtoRLtext1:SetFont(Turbine.UI.Lotro.Font.Verdana16);
IGtoRLtext1:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
IGtoRLtext1:SetReadOnly(true);
IGtoRLtext1:SetVisible(true);
IGtoRLtext1:SetText( "All occurrences of desired time" );

IGtoRLtext2 = Turbine.UI.Lotro.TextBox();
IGtoRLtext2:SetParent(label2);
IGtoRLtext2:SetPosition(275, 78);
IGtoRLtext2:SetSize(150, 20);
IGtoRLtext2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
IGtoRLtext2:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
IGtoRLtext2:SetReadOnly(true);
IGtoRLtext2:SetVisible(true);
IGtoRLtext2:SetText( " days from now:      " );

IGtoRLinput = Turbine.UI.Lotro.TextBox();
IGtoRLinput:SetParent(label2);
IGtoRLinput:SetPosition(235, 78);
IGtoRLinput:SetSize(40, 20);
IGtoRLinput:SetFont(Turbine.UI.Lotro.Font.Verdana16);
IGtoRLinput:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
IGtoRLinput:SetReadOnly(false);
IGtoRLinput:SetVisible(true);
IGtoRLinput:SetText( "0" );
IGtoRLinput:SetOutlineColor( Turbine.UI.Color( 0, 1, 0 ) );
 IGtoRLinput:SetFontStyle( Turbine.UI.FontStyle.Outline );
IGtoRLinput:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );

IGtoRLinputtext = IGtoRLinput:GetText();


IGtoRLoutput1 = Turbine.UI.Lotro.TextBox();
IGtoRLoutput1:SetParent(label2);
IGtoRLoutput1:SetPosition(160, 100);
IGtoRLoutput1:SetSize(75, 65);
IGtoRLoutput1:SetFont(Turbine.UI.Lotro.Font.Verdana16);
IGtoRLoutput1:SetBackColor( Turbine.UI.Color(0.2, 0.5, 1) );
IGtoRLoutput1:SetForeColor( Turbine.UI.Color(1, 0.85, 0) );
IGtoRLoutput1:SetReadOnly(false);
IGtoRLoutput1:SetVisible(true);
IGtoRLoutput1:SetText( "12:34am\n12:34am\n12:34am\n12:34am"  );
IGtoRLoutput1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );

IGtoRLoutput2 = Turbine.UI.Lotro.TextBox();
IGtoRLoutput2:SetParent(label2);
IGtoRLoutput2:SetPosition(235, 100);
IGtoRLoutput2:SetSize(75, 65);
IGtoRLoutput2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
IGtoRLoutput2:SetBackColor( Turbine.UI.Color(0.2, 0.5, 1) );
IGtoRLoutput2:SetForeColor( Turbine.UI.Color(1, 0.85, 0) );
IGtoRLoutput2:SetReadOnly(false);
IGtoRLoutput2:SetVisible(true);
IGtoRLoutput2:SetText( "98:78pm\n98:78pm\n98:78pm\n98:78pm" );
IGtoRLoutput2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );


-- End IG->RL



-- Start RL -> IG
RLtoIGinput1 = Turbine.UI.Lotro.TextBox();
RLtoIGinput1:SetParent(label3);
RLtoIGinput1:SetPosition(0, 8);
RLtoIGinput1:SetSize(35, 20);
RLtoIGinput1:SetFont(Turbine.UI.Lotro.Font.Verdana16);
RLtoIGinput1:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
RLtoIGinput1:SetReadOnly(false);
RLtoIGinput1:SetVisible(true);
RLtoIGinput1:SetText( "0" );
RLtoIGinput1:SetOutlineColor( Turbine.UI.Color( 0, 1, 0 ) );
 RLtoIGinput1:SetFontStyle( Turbine.UI.FontStyle.Outline );
RLtoIGinput1:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );

RLtoIGinput2 = Turbine.UI.Lotro.TextBox();
RLtoIGinput2:SetParent(label3);
RLtoIGinput2:SetPosition(43, 8);
RLtoIGinput2:SetSize(35, 20);
RLtoIGinput2:SetFont(Turbine.UI.Lotro.Font.Verdana16);
RLtoIGinput2:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
RLtoIGinput2:SetReadOnly(false);
RLtoIGinput2:SetVisible(true);
RLtoIGinput2:SetText( "0" );
RLtoIGinput2:SetOutlineColor( Turbine.UI.Color( 0, 1, 0 ) );
 RLtoIGinput2:SetFontStyle( Turbine.UI.FontStyle.Outline );
RLtoIGinput2:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );

RLtoIGinput3 = Turbine.UI.Lotro.TextBox();
RLtoIGinput3:SetParent(label3);
RLtoIGinput3:SetPosition(89, 8);
RLtoIGinput3:SetSize(35, 20);
RLtoIGinput3:SetFont(Turbine.UI.Lotro.Font.Verdana16);
RLtoIGinput3:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
RLtoIGinput3:SetReadOnly(false);
RLtoIGinput3:SetVisible(true);
RLtoIGinput3:SetText( "0" );
RLtoIGinput3:SetOutlineColor( Turbine.UI.Color( 0, 1, 0 ) );
 RLtoIGinput3:SetFontStyle( Turbine.UI.FontStyle.Outline );
RLtoIGinput3:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );




waswillbe = "will be: Night-time:";
if ( (tonumber(RLtoIGinput1:GetText())*86400 + tonumber(RLtoIGinput2:GetText())*3600 + 60*tonumber(RLtoIGinput3:GetText()) ) < 0 ) then
  waswillbe = "was:";
end

label3:SetFont(Turbine.UI.Lotro.Font.Verdana14);
label3:SetText("\n        d       h        m");

RLtoIGtext4 = Turbine.UI.Lotro.TextBox();
RLtoIGtext4:SetParent(label3);
RLtoIGtext4:SetPosition(140, 8);
 RLtoIGtext4:SetSize(140, 20);
RLtoIGtext4:SetFont(Turbine.UI.Lotro.Font.Verdana16);
RLtoIGtext4:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
RLtoIGtext4:SetReadOnly(true);
RLtoIGtext4:SetVisible(true);
RLtoIGtext4:SetText( "from now, it " .. waswillbe );

RLtoIGoutput = Turbine.UI.Lotro.TextBox();
RLtoIGoutput:SetParent(label3);
-- RLtoIGoutput:SetPosition(0, 30);
RLtoIGoutput:SetPosition(280, 8);
RLtoIGoutput:SetSize(190, 20);
RLtoIGoutput:SetFont(Turbine.UI.Lotro.Font.Verdana16);
RLtoIGoutput:SetBackColor( Turbine.UI.Color(0.2, 0.5, 1) );
RLtoIGoutput:SetForeColor( Turbine.UI.Color(1, 0.85, 0) );
RLtoIGoutput:SetReadOnly(false);
RLtoIGoutput:SetVisible(true);
RLtoIGoutput:SetText( "12:34am\n12:34am\n12:34am\n12:34am"  );
RLtoIGoutput:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );



RLtoIGupdate = function(sender, args)

    waswillbe = "will be: Night-time:";
      if ( RLtoIGinput1:GetText() ~= nil and RLtoIGinput2:GetText() ~= nil and RLtoIGinput3:GetText() ~= nil) then
        if ( (tonumber(RLtoIGinput1:GetText())*86400 + tonumber(RLtoIGinput2:GetText())*3600 + 60*tonumber(RLtoIGinput3:GetText()) )  < 0  ) then
           waswillbe = "was:";
        end 
      else
        RLtoIGoutput:SetText("Invalid entry.");
      end -- if(tonumber(notnil) )
   
      RLtoIGtext4:SetText( "from now it " .. waswillbe );

   days = tonumber( RLtoIGinput1:GetText() );
   hours = tonumber( RLtoIGinput2:GetText() );
   minutes = tonumber( RLtoIGinput3:GetText() );


   if (days == nil) or (hours == nil) or (minutes == nil) then
      if (days == nil) then
         Turbine.Shell.WriteLine("Invalid value for 'Days' ... ");
      end
      if (hours == nil) then
         Turbine.Shell.WriteLine("Invalid value for 'Hours' ... ");
      end
      if (minutes == nil) then
         Turbine.Shell.WriteLine("Invalid value for 'Minutes' ... ");
      end
      days = 0;
      hours = 0;
      minutes = 0;
      timer = "Invalid time";
   else

      difftimer = minutes*60 + hours*3600 + days*86400;
     getIGtimetext();

      RLtoIGoutput:SetText( timer  );
     difftimer = 0;
     getIGtimetext();
end -- if(days=nil)

     

end -- RLtoIGupdate



-- End RL -> IG




-- Start countdown to next IG
countdowntext = Turbine.UI.Lotro.TextBox();
countdowntext:SetParent(label2);
countdowntext:SetPosition(25, 50);
countdowntext:SetSize(380, 20);
countdowntext:SetFont(Turbine.UI.Lotro.Font.Verdana16);
countdowntext:SetBackColor( Turbine.UI.Color(0.2, 0.5, 1) );
countdowntext:SetForeColor( Turbine.UI.Color(1, 0.85, 0) );
countdowntext:SetReadOnly(true);
countdowntext:SetVisible(true);
countdowntext:SetText("0");

settimtext = Turbine.UI.Lotro.TextBox();
settimtext:SetParent(label2);
settimtext:SetPosition(55,5);
settimtext:SetSize(145, 20);
settimtext:SetFont(Turbine.UI.Lotro.Font.Verdana16);
settimtext:SetBackColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
settimtext:SetReadOnly(true);
settimtext:SetVisible(true);
settimtext:SetText("Select desired time:");

topmenu = Turbine.UI.Lotro.GoldButton();
topmenu:SetParent(label2);
topmenu:SetSize(200, 13);
topmenu:SetPosition(25, 25);
topmenu:SetText("Day-time: Dawn");
endarraypos = 1;
endarraycheck = endarraypos;
topitemselect = "Day-time: Dawn";

RLtoIGoutput:SetText( topitemselect );

topmenu.MouseDown = function(sender, args)

 topcontextmenu = Turbine.UI.ContextMenu();
 topmenuitems = topcontextmenu:GetItems();
 topmenuitems:Add( Turbine.UI.MenuItem( "Day-time: Dawn" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Day-time: Morning" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Day-time: Noon" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Day-time: Afternoon" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Day-time: Dusk" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Night-time: Gloaming" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Night-time: Evening" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Night-time: Midnight" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Night-time: Late Watches" ) );
 topmenuitems:Add( Turbine.UI.MenuItem( "Night-time: Foredawn" ) );

 for i=1, topmenuitems:GetCount() do
  local topmenuitem = topmenuitems:Get( i );
  local topitemtext = topmenuitem:GetText();

  topmenuitem.Click = function(sender, args)
   topitemselect = topitemtext;
   topmenu:SetText(topitemselect);
   endarraypos = i;   -- this is the index for the selected menu item
   -- Debug line:
   -- Turbine.Shell.WriteLine( "You have selected " .. topitemselect .. ", endarraypos = " .. endarraypos .. "." );

  end -- topmenuitem.click
 end -- for i=1
topcontextmenu:ShowMenu();
end -- topmenu.mousedown


zoneoutput = "+" .. math.floor( (-1)*timezone ) .. " GMT.";
durationarraypos = 1;
durationarray = {572, 1722, 1067, 1678, 1101, 570, 1679, 539, 1141, 1091};
minifunctionflag = 0;


countdown = function(sender, args)

 if (durationarraypos >= endarraypos) then
  endarraypos = endarraypos + 10;
 end -- if(durationarraypos>endarraypos)

 countdownsec = 0;

 if (endarraypos ~= durationarraypos + 1) then    -- if the selected menu item is not the very next IG time then do

   for j = durationarraypos + 1, endarraypos-1 do
    k = j;
    if (j>10) then
     k = j-10
    end -- if(j>10)

    countdownsec = countdownsec + durationarray[k];  -- countdownsec counts duration from start of next IG time to start of endmenu IG time
   end -- for j 

 end -- if(endarraypos~=durationarraypos+1)


 nowtime = Turbine.Engine.GetLocalTime();
 timesincedawn = (nowtime - InitDawn) % 11160;
 tempIGduration = 0;

 for m = 1, durationarraypos do
   tempIGduration = tempIGduration + durationarray[m]; -- duration from dawn through next IG time
 end -- for m
 
 nowIGduration = tempIGduration - timesincedawn;  -- duration left for current IG time is equal to (time from dawn to next IG time) minus (time from now since last dawn)
 totalseconds = nowIGduration + countdownsec;  -- total time is equal to (time remaining on current IG time) plus (time from start of next IG time to start of endmenu IG time)

 -- now, convert totalseconds into hrs, mins, and secs
 cdhours = math.floor( totalseconds / 3600 );
 cdminutes = math.floor( 60*( (totalseconds / 3600) - cdhours) );
 cdseconds = math.floor( 60*(60*( (totalseconds/3600) - cdhours ) - cdminutes) + 0.5 );  -- when done debugging, do not use seconds


if (cdminutes == 59) then
  cdminutesout = 0;
  cdhoursout = cdhours + 1;
else
  cdminutesout = cdminutes + 1;
  cdhoursout = cdhours;
end -- if(cdminutes==59) 
 -- countdowntext:SetText(": countdownsec = " .. countdownsec .. ", cdhours = " .. cdhours  .. ", cdminutes = " .. cdminutes .. ", cdseconds " .. cdseconds ); -- remove seconds after done debugging

  if (minifunctionflag < 1) then
countdowntext:SetText( topmenu:GetText() .. " will occur in approx " .. cdhoursout  .. "h " .. cdminutesout .. "m" ); 
end -- if(minifunctionflag)

minifunctionflag = 0;

-- IGtoRLtext1:SetText( "All events of " .. topmenu:GetText() );


end -- countdown function

countdown();

-- End countdown to next IG




-- Start IGtoRL update function

IGtoRLupdate = function(sender, args)

IGtoRLinputtext = IGtoRLinput:GetText();

getdate = Turbine.Engine.GetDate();
currenthour = getdate.Hour;
currentminute = getdate.Minute;
isDST = getdate.IsDST;  -- Day Light Savings adjustment

dstvar = 1;
if (isDST) then
    dstvar = 0;
end  --if(isDST)



timezone = math.floor((Turbine.Engine.GetLocalTime() % 86400) / 3600) - currenthour;
currentampm = "am";  -- initialize currentampm

--start enter
InputDays = tonumber(IGtoRLinputtext);
   if (InputDays == nil) then
      Turbine.Shell.WriteLine("Invalid value for 'Days' ... ");
   else


      if (topitemselect == "Day-time: Dawn") then -- selectedItem => topitemselect
         selecteditemtime = InitDawn;
         selecteditemduration = durationarray[1];
      elseif (topitemselect == "Day-time: Morning") then
         selecteditemtime = InitDawn + durationarray[1];
         selecteditemduration = durationarray[2];
      elseif (topitemselect == "Day-time: Noon") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2];
         selecteditemduration = durationarray[3];
      elseif (topitemselect == "Day-time: Afternoon") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2] + durationarray[3];
         selecteditemduration = durationarray[4];
      elseif (topitemselect == "Day-time: Dusk") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2] + durationarray[3] + durationarray[4];
         selecteditemduration = durationarray[5];
      elseif (topitemselect == "Night-time: Gloaming") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2] + durationarray[3] + durationarray[4] + durationarray[5];
         selecteditemduration = durationarray[6];
      elseif (topitemselect == "Night-time: Evening") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2] + durationarray[3] + durationarray[4] + durationarray[5] + durationarray[6];
         selecteditemduration = durationarray[7];
      elseif (topitemselect == "Night-time: Midnight") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2] + durationarray[3] + durationarray[4] + durationarray[5] + durationarray[6] + durationarray[7];
         selecteditemduration = durationarray[8];
      elseif (topitemselect == "Night-time: Late Watches") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2] + durationarray[3] + durationarray[4] + durationarray[5] + durationarray[6] + durationarray[7] + durationarray[8];
         selecteditemduration = durationarray[9];
      elseif (topitemselect == "Night-time: Foredawn") then
         selecteditemtime = InitDawn + durationarray[1] + durationarray[2] + durationarray[3] + durationarray[4] + durationarray[5] + durationarray[6] + durationarray[7] + durationarray[8] + durationarray[9];
         selecteditemduration = durationarray[10];
      else
         selecteditemtime = 1;
         selecteditemduration = 2;
      end      -- if(topitemselect="daytime:dawn")



      SImins = math.floor(selecteditemduration/60);
      SIsecs = math.floor( ( (selecteditemduration - 60*SImins) % 60) + 0.5);


  -- do calculations for InGameToRL.button
 
      TZadjust = timezone*3600;
 if (dstvar == 1) then
 TZadjust = timezone*3600 - 3600 ;
 timezone = timezone-1;
 end    -- if(dstvar=1)
 
      DLSadjust = 0;
      localtime = Turbine.Engine.GetLocalTime();
      PreviousRLMidnight = Turbine.Engine.GetLocalTime() - ( Turbine.Engine.GetLocalTime() % 86400 );  -- This is GMT midnight
      StartRLMidnight = PreviousRLMidnight + InputDays*86400 + TZadjust ; -- + 3600;                   -- This is local time

      outputtime = StartRLMidnight   - ( (StartRLMidnight - selecteditemtime) % 11160) ; -- + 11160*(dstvar+1) ;
-- DEBUG TXT, NEXT LINE (2 of 2 ... see further up page)
 --   Turbine.Shell.WriteLine("Programmer Notes: initial outputtime = " .. dstvar .. ", " .. outputtime .. ", localtime = " .. localtime .. ", StartRLMidnight = " .. StartRLMidnight .. ", PreviousRLMidnight = " .. PreviousRLMidnight .. ", selectedItem = " .. topitemselect .. ", selecteditemtime = " .. selecteditemtime .. ", timezone = " .. timezone .. ", currenthour = " .. currenthour .. ".");


      if (currenthour >11) then
         currentampm = "pm";
      else
         currentampm = "am";
      end   -- if(currenthour>11)

      if (currenthour > 12) then
         currenthour = currenthour - 12;
      end

      if (currentminute < 10) then
         currentminute = "0" .. currentminute;
      end   --if(currentminute<10)

 --     Turbine.Shell.WriteLine("Current RL time is " .. currenthour .. ":" .. currentminute .. currentampm .. ".");
 --     Turbine.Shell.WriteLine(topitemselect .. " duration lasts " .. SImins .. " minutes and " .. SIsecs .. " seconds.");
 --     Turbine.Shell.WriteLine("Getting times for " ..  topitemselect .. ", " .. InputDays .. " RL days from now...");

      cutofftime = StartRLMidnight + 86400; --  - 11160*(dstvar+1); -- + 3600*(dstvar+1) ;

      SImins = math.floor(selecteditemduration/60);
      SIsecs = math.floor( ( (selecteditemduration - 60*SImins) % 60) + 0.5);
      
      IGtoRLarray = {0, 0, 0, 0, 0, 0, 0, 0, 0};
starterindex = 1;
starterflag = 1;

      for k=1, 10, 1 do
       
            outputhr = math.floor( (86400 - cutofftime + outputtime) / 3600 );
            
            if (not isDST) then
               outputhr = outputhr - 1;
            end  -- if(not isDST)
 
            outputmin = math.floor( ( ((86400 - cutofftime + outputtime) / 3600) - outputhr )*60 +0.5) - 60*dstvar;

         if (outputmin < 10) then
            outputmin = "0" .. outputmin;
         end  -- if(outputmin<10)

         outputhrmod = outputhr % 12;
         if (outputhrmod == 0) then
            outputhrmod = 12;
         end     -- if(outputhrmod=0)
outputhrmod = " " .. outputhrmod;

         AMPM = "am";
         if (outputhr > 11) then
            AMPM = "pm";
         end     -- if(outputhr>11)
         
         IGtoRLarray[k] =  outputhrmod .. ":" .. outputmin .. AMPM;

if (outputhr < 0) then
  if ( starterflag >0) then
      starterindex = starterindex + 1;
   end -- if(starterflag>0)
else
   starterflag = 0;
 end -- if(outputhr>3)


 --        Turbine.Shell.WriteLine(topitemselect .. " occurs at " .. outputhrmod .. ":" .. outputmin .. AMPM .. ".");

 --        end  -- if(outputtime<=cutofftime)

         outputtime = outputtime + 11160;

      end  -- for k=1, 10
   if (timezone < -12) then

      timezone = 24 + timezone;

   end   -- if(timezone<-12)

   if (timezone > 12) then

      timezone = timezone - 24;

   end   -- if(timezone>12)
   
   
   if (timezone == 4) then
      zoneoutput = "Eastern U.S.";
   elseif (timezone == 5) then
      zoneoutput = "Central U.S.";
   elseif (timezone == 6) then
      zoneoutput = "Mountain U.S.";
   elseif (timezone == 7) then
      zoneoutput = "Pacific U.S.";
   elseif (timezone > 0) and (timezone < 4) then
      zoneoutput = "-" .. timezone .. " GMT.";
   elseif (timezone > 7) then
      zoneoutput = "-" .. timezone .. " GMT.";
   elseif (timezone == 0) then
      zoneoutput = "+" .. timezone .. " GMT.";
   else
      zoneoutput = "+" .. math.floor( (-1)*timezone ) .. " GMT.";
   end  --if(timezone=4)


 --  Turbine.Shell.WriteLine("All times are " .. zoneoutput);

   end  -- if(inputdays=nil)
--end enter

IGtoRLoutput1:SetText( IGtoRLarray[starterindex] ..  IGtoRLarray[starterindex+1]  ..  IGtoRLarray[starterindex+2]  .. IGtoRLarray[starterindex+3] );
IGtoRLoutput2:SetText( IGtoRLarray[starterindex+4] ..  IGtoRLarray[starterindex+5]  ..  IGtoRLarray[starterindex+6]  .. IGtoRLarray[starterindex+7] );
 
 label2:SetText("All times are " .. zoneoutput);

end -- IGtoRLupdate function

 IGtoRLupdate();

-- end IGtoRLupdate 



-- Start alarm function

alarmtext = Turbine.UI.Lotro.TextBox();
alarmtext:SetParent(label2);
alarmtext:SetPosition(280, 5);
alarmtext:SetSize(85, 20);
alarmtext:SetFont(Turbine.UI.Lotro.Font.Verdana16);
alarmtext:SetBackColor( Turbine.UI.Color( 0.5, 0.5, 0.5) );
alarmtext:SetReadOnly(true);
alarmtext:SetVisible(true);
alarmtext:SetText("Set Alarm: ");

alarmmenu = Turbine.UI.Lotro.GoldButton();
alarmmenu:SetParent(label2);
alarmmenu:SetSize(160, 13);
alarmmenu:SetPosition(245, 25);
alarmmenu:SetText("None");

alarmindex = 1;

alarmmenu.MouseDown = function(sender, args)

 alarmcontextmenu = Turbine.UI.ContextMenu();
 alarmmenuitems = alarmcontextmenu:GetItems();
 alarmmenuitems:Add( Turbine.UI.MenuItem( "None" ) );-- 1
 alarmmenuitems:Add( Turbine.UI.MenuItem( "60 min before start" ) );-- 2
 alarmmenuitems:Add( Turbine.UI.MenuItem( "30 min before start" ) );-- 3
 alarmmenuitems:Add( Turbine.UI.MenuItem( "15 min before start" ) );-- 4
 alarmmenuitems:Add( Turbine.UI.MenuItem( "10 min before start" ) );-- 5
 alarmmenuitems:Add( Turbine.UI.MenuItem( "5 min before start" ) );-- 6
 alarmmenuitems:Add( Turbine.UI.MenuItem( "1 min before start" ) );-- 7
 alarmmenuitems:Add( Turbine.UI.MenuItem( "5 min from now" ) );-- 8
 alarmmenuitems:Add( Turbine.UI.MenuItem( "10 min from now" ) );-- 9
 alarmmenuitems:Add( Turbine.UI.MenuItem( "15 min from now" ) );-- 10
 alarmmenuitems:Add( Turbine.UI.MenuItem( "30 min from now" ) );-- 11
 alarmmenuitems:Add( Turbine.UI.MenuItem( "60 min from now" ) );-- 12

 for n=1, alarmmenuitems:GetCount() do
  local alarmmenuitem = alarmmenuitems:Get( n );
  local alarmitemtext = alarmmenuitem:GetText();

  alarmmenuitem.Click = function(sender, args)
   alarmitemselect = alarmitemtext;
   alarmmenu:SetText(alarmitemselect);
   alarmindex = n;
  
 if (alarmindex == 2) then
  alerttime = 60;
  alertsequence = "before";
 elseif (alarmindex == 3) then
  alerttime = 30;
  alertsequence = "before";
 elseif (alarmindex == 4) then
  alerttime = 15;
  alertsequence = "before";
 elseif (alarmindex == 5) then
  alerttime = 10;
  alertsequence = "before";
 elseif (alarmindex == 6) then
  alerttime = 5;
  alertsequence = "before";
 elseif (alarmindex == 7) then
  alerttime = 1;
  alertsequence = "before";
 elseif (alarmindex == 8) then
  alerttime = 5;
  alertsequence = "now";
 elseif (alarmindex == 9) then
  alerttime = 10;
  alertsequence = "now";
 elseif (alarmindex == 10) then
  alerttime = 15;
  alertsequence = "now";
 elseif (alarmindex == 11) then
  alerttime = 30;
  alertsequence = "now";
 elseif (alarmindex == 12) then
  alerttime = 60;
  alertsequence = "now";
 else
  alerttime = 0;
  alertsequence = "now";
 end -- if(alarmindex==2)
  end -- alarmmenuitem.click
 end -- for n=1
alarmcontextmenu:ShowMenu();
end -- alarmmenu.mousedown

alarmwindow = Turbine.UI.Lotro.Window();
alarmwindow:SetPosition( 150, 150 ); 
alarmwindow:SetSize( 400, 345 ); 
alarmwindow:SetText( "PigT Alarm" );
alarmwindow:SetVisible( false );

alarmwindowtext = Turbine.UI.Lotro.TextBox();
alarmwindowtext:SetParent(alarmwindow);
alarmwindowtext:SetPosition(40, 40);
alarmwindowtext:SetSize(320, 200);
alarmwindowtext:SetMultiline(true);
alarmwindowtext:SetFont(Turbine.UI.Lotro.Font.Verdana22);
alarmwindowtext:SetBackColor(Turbine.UI.Color(1, 0.2, 0.2, 0.5) );
alarmwindowtext:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
alarmwindowtext:SetVisible(true)
alarmwindowtext:SetText("Whoops, nothing selected.");

alarmwindowbutton = Turbine.UI.Lotro.Button();
alarmwindowbutton:SetParent(alarmwindow);
alarmwindowbutton:SetSize(130, 13);
alarmwindowbutton:SetPosition(140, 260);
alarmwindowbutton:SetText("PigT Main");



alarmwindowbutton.Click = function(sender, args)

 parentwindow:SetVisible(true);
 alarmwindow:SetVisible(false);

end -- alarmwindowbutton click


alarmcounter = 0;

alarm = function(sender, args)

 alarmcounter = alarmcounter + 1;

 if (alertsequence == "before" and totalseconds - 60*alerttime == 0 and f12flag == 0) then
  alertmessage = topmenu:GetText() .. " will occur in approx " .. alerttime .. " minutes.";
  alarmwindow:SetVisible(true);
  alarmwindow:Activate();
  alarmwindow:Focus();
  alarmwindowtext:SetText(alertmessage) ;
  alarmcounter = 0;
  alarmmenu:SetText("None");
  alarmindex = 1;
 elseif (alertsequence == "now" and alarmcounter >= 60*alerttime and f12flag == 0) then
  alertmessage = "It has been " .. alerttime .. " minutes since you set your PigT alarm.";
  alarmwindow:SetVisible(true);
  alarmwindow:Activate();
  alarmwindow:Focus();
  alarmwindowtext:SetText(alertmessage) ;
  alarmcounter = 0;
  alarmmenu:SetText("None");
  alarmindex = 1;
 elseif (alertsequence == "before" and totalseconds - 60*alerttime < 0 and f12flag == 0) then
  alertmessage = topmenu:GetText() .. " will occur in approx " .. cdminutesout .. " minutes.";
  alarmwindow:SetVisible(true);
  alarmwindow:Activate();
  alarmwindow:Focus();
  alarmwindowtext:SetText(alertmessage) ;
  alarmcounter = 0;
  alarmmenu:SetText("None");
  alarmindex = 1;
 end -- if(alertsequence=before and stuff)

end -- alarm function

-- End alarm function

minimizearray = {"Day-time: Dawn", "Day-time: Morning", "Day-time: Noon", "Day-time: Afternoon", "Day-time: Dusk", "Night-time: Gloaming", "Night-time: Evening",  "Night-time: Midnight", "Night-time: Late Watches", "Night-time: Foredawn"}; 

minimizearraysmall = {"Dawn", "Morning", "Noon", "Afternoon", "Dusk", "Gloaming", "Evening",  "Midnight", "Late Watches", "Foredawn"};


minimizemovewindow = Turbine.UI.Window();
minimizemovewindow:SetPosition(mouseposx, mouseposy-8);
minimizemovewindow:SetSize(155, 10);
minimizemovewindow:SetBackColor(Turbine.UI.Color(0.8, 0, 0, 0));
minimizemovewindow:SetVisible(false);

minimizemovewindowtext = Turbine.UI.TextBox();
minimizemovewindowtext:SetParent(minimizemovewindow);
minimizemovewindowtext:SetSize(155, 10);
minimizemovewindowtext:SetReadOnly(true);
minimizemovewindowtext:SetSelectable(false);
minimizemovewindowtext:SetMouseVisible(true);
minimizemovewindowtext:SetText("PigT mini-window");


minimizewindow = Turbine.UI.Window();
minimizewindow:SetPosition(mouseposx, mouseposy+2);
minimizewindow:SetSize(155, 25);
minimizewindow:SetBackColor( Turbine.UI.Color( 0, 0.1, 0.1, 0.1 ) );
if (opts.minishow == "yes") then
  minimizewindow:SetVisible(true);
else
  minimizewindow:SetVisible(false);
end -- if(minivisible)


minitextbox = Turbine.UI.TextBox();
minitextbox:SetParent(minimizewindow);
minitextbox:SetReadOnly(true);
minitextbox:SetSelectable(false);
minitextbox:SetMouseVisible(true);
minitextbox:SetPosition(0, 0);
minitextbox:SetSize(155, 25);
minitextbox:SetForeColor(Turbine.UI.Color( 1, 1, 1 ) );


minibutton = Turbine.UI.Lotro.Button();
minibutton:SetParent(parentwindow);
minibutton:SetPosition(420, 35);
minibutton:SetSize(50, 20);
minibutton:SetText("Min");
minibutton:SetVisible(true);

minibutton.Click = function(sender, args)
 
   minimizewindow:SetVisible( not minimizewindow:IsVisible() );
   if (minimizewindow:IsVisible()) then
     opts.minishow = "yes";
   else
     opts.minishow = "no";
   end -- if(minimizewindowisvisible)
   Turbine.PluginData.Save(Turbine.DataScope.Character, "pigt_opts", opts);

end --minibutton.click

mouseposgetupdates = false;


minitextbox.MouseDown = function(sender, args)
 
     parentwindow:SetVisible(not parentwindow:IsVisible() );

end -- minitextbox mousedown

minimizemovewindowtext.MouseDown = function(sender, args)
 
   mouseposgetupdates = true; 

end -- minitextbox mousedown

minimizemovewindowtext.MouseUp = function(sender, args)

   mouseposgetupdates=false;

   mouseposx, mouseposy = hiddenwindow:GetMousePosition();
   opts.mouseposx = mouseposx;
   opts.mouseposy = mouseposy;
   Turbine.PluginData.Save(Turbine.DataScope.Character, "pigt_opts", opts)
  
end -- minitextbox mouseup





minitextbox.MouseEnter = function(sender, args)
    minimizewindow:SetBackColor( Turbine.UI.Color( 1, 0.1, 0.1, 0.1 ) );
end -- minitextbox mouseover


minitextbox.MouseLeave = function(sender, args)
    minimizewindow:SetBackColor( Turbine.UI.Color( 0, 0.1, 0.1, 0.1 ) );
end -- minitextbox mouseover

minimizeindex = 1;


--start func
minifunction = function(sender, args)

for n=1, 10, 1 do

  if (currentIGtimetext:GetText() == minimizearray[n]) then
     minimizeindex = n+1;
     prevminimizeindex = n;
     if (n==10) then
       minimizeindex = 1;
     end
  end -- if(currentigtimextex)
end --n=1


nowIGduration = tempIGduration - timesincedawn;  -- duration left for current IG time is equal to (time from dawn to next IG time) minus (time from now since last dawn)
 totalseconds = nowIGduration ;  -- total time is equal to (time remaining on current IG time)

 -- now, convert totalseconds into hrs, mins, and secs
 cdhours = math.floor( totalseconds / 3600 );
 cdminutes = math.floor( 60*( (totalseconds / 3600) - cdhours) );
 cdseconds = math.floor( 60*(60*( (totalseconds/3600) - cdhours ) - cdminutes) + 0.5 );  -- when done debugging, do not use seconds


if (cdminutes == 59) then
  cdminutesout = 0;
  cdhoursout = cdhours + 1;
else
  cdminutesout = cdminutes + 1;
  cdhoursout = cdhours;
end -- if(cdminutes==59)



minitextbox:SetText( currentRLtimetext:GetText() .. ": " .. minimizearraysmall[prevminimizeindex] .. "\n("  .. cdminutesout .. " min) " .. minimizearraysmall[minimizeindex]  );
minitextbox:SetVisible(true);

end -- minifunction


minifunction();
--end func


 

-- Start Control for updates

updateControl = Turbine.UI.Control();

 updateControl:SetWantsUpdates(true);
 
updateControl.Update = function(sender, args)

 if (oldtime ~= currentsecond) then  -- run these functions once every second
  getRLtimetext();
  getIGtimetext();
  countdown();
  if (alarmindex > 1) then
    alarm();
-- Turbine.Shell.WriteLine("alarmindex = " .. alarmindex .. ", alerttime = " .. alerttime .. ", alertsequence = " .. alertsequence .. ", totalseconds = " .. totalseconds .. ", nowtime = " .. nowtime );
  end -- if(alarmindex>1)

  if (IGtoRLinputtext ~= IGtoRLinput:GetText() ) then
    IGtoRLupdate();
    IGtoRLinputtext = IGtoRLinput:GetText();
  elseif (endarraycheck ~= endarraypos ) then  
    IGtoRLupdate();
    endarraycheck = endarraypos;
  end -- if(IGtoRLinputtext~=IGtoRLinput:GetText())
  
  if ( tonumber( RLtoIGinput1:GetText() ) ~= nil and tonumber( RLtoIGinput2:GetText() ) ~= nil and tonumber( RLtoIGinput3:GetText() ) ~= nil) then 
    RLtoIGupdate();
  else
    RLtoIGoutput:SetText("Invalid entry.");
  end -- if(tonumber(notnil) )

  minifunction();

  end --if (oldtime ~= currentsecond)

 getTime(); -- run this function every frame

 if(mouseposgetupdates) then
      posx, posy = hiddenwindow:GetMousePosition();
      posx = posx-2;
      posy=posy-8;
      minimizemovewindow:SetPosition( posx, posy );
      minimizewindow:SetPosition(posx, posy+10);
  end -- if(mouseposgetupdates)



end  --updateControl

-- End Control for Updates



-- INSERT SHELL COMMAND HERE...

pigtcommand = Turbine.ShellCommand();


function pigtcommand:Execute( command, arguments )

if ( arguments == "help" ) then
Turbine.Shell.WriteLine("Use the command '/pigt' to open or close PredictInGame.\nFor more info visit http://my.lotro.com/scrappythegreat/predict-in-game-time-updater/");
else
parentwindow:SetVisible( not parentwindow:IsVisible() );
end

end

Turbine.Shell.AddCommand( "pigt;predictingametime", pigtcommand );


   if (parentwindow:IsVisible() ) then visarray[1] = 1; else visarray[1]=0; end
    if (minimizewindow:IsVisible() ) then visarray[2] = 1; else visarray[2]=0; end
    if (alarmwindow:IsVisible() ) then visarray[3] = 1; else visarray[3]=0; end
    if (helpwindow:IsVisible() ) then visarray[4] = 1; else visarray[4]=0; end


minimizemovewindowtoggle = 0;
hiddenwindow.KeyDown = function(sender, args)
 if (args.Action == 268435635) then
    f12flag = (f12flag+1)%2;
   if (f12flag == 1) then

       if (parentwindow:IsVisible() ) then visarray[1] = 1; else visarray[1]=0; end
       if (minimizewindow:IsVisible() ) then visarray[2] = 1; else visarray[2]=0; end
       if (alarmwindow:IsVisible() ) then visarray[3] = 1; else visarray[3]=0; end
       if (helpwindow:IsVisible() ) then visarray[4] = 1; else visarray[4]=0; end 
       if (minimizemovewindow:IsVisible() ) then visarray[5] = 1; else visarray[5]=0; end

       parentwindow:SetVisible(false);
       minimizewindow:SetVisible(false);
       alarmwindow:SetVisible(false);
       helpwindow:SetVisible(false);
       minimizemovewindow:SetVisible(false);
    else
       if (visarray[1] == 1) then parentwindow:SetVisible(true); end
       if (visarray[2] == 1) then minimizewindow:SetVisible(true); end
       if (visarray[3] == 1) then alarmwindow:SetVisible(true); end
       if (visarray[4] == 1) then helpwindow:SetVisible(true); end
       if (visarray[5] == 1) then minimizemovewindow:SetVisible(true); end
    end -- if(f12flag)
 end -- if(args.Action=268435635

  if (args.Action == 268435579) then
     minimizemovewindowtoggle = (minimizemovewindowtoggle+1)%2;
   if (minimizemovewindowtoggle == 1) then
     minimizemovewindow:SetVisible(true);
   else
     minimizemovewindow:SetVisible(false);
   end  -- if (minimizemovewindowtoggle
  end -- if(args.Action=268435579 

  --  Turbine.Shell.WriteLine(args.Action .. " you got it right " .. visarray[1] .. visarray[2] .. visarray[3] .. visarray[4] .. ".");
 end -- hiddenwindow keydown



optionsmainwindowcheck1.CheckedChanged = function(sender, args)
 
     openparentwindowstartup = not openparentwindowstartup;
     opts.openparentwindowstartup = openparentwindowstartup;
     optionsmainwindowcheck1:SetChecked( openparentwindowstartup );
     Turbine.PluginData.Save(Turbine.DataScope.Character, "pigt_opts", opts);
--   Turbine.Shell.WriteLine(tostring(opts.openparentwindowstartup));


end -- optionsmainwindowcheck1 checkedchanged function


optionsbutton.Click = function(sender, args)
 
       optionswindow:SetVisible( not optionswindow:IsVisible() );

end -- optsbutton click function

label2:SetText("All times are " .. zoneoutput);
--nowtime = Turbine.Engine.GetLocalTime();
--gametime = math.floor( Turbine.Engine.GetGameTime() );
--diff = nowtime - gametime;
-- Turbine.Shell.WriteLine(diff .. " ,  " .. timezone);